"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MobileWalletButton = MobileWalletButton;
var tslib_1 = require("tslib");
var common_1 = require("./common");
var react_1 = tslib_1.__importStar(require("react"));
var CoinflowIFrame_1 = require("./CoinflowIFrame");
var useOverlay_1 = require("./useOverlay");
function MobileWalletButton(_a) {
    var props = _a.props, route = _a.route, overlayDisplayOverride = _a.overlayDisplayOverride, children = _a.children, alignItems = _a.alignItems;
    var iframeRef = (0, react_1.useRef)(null);
    var _b = (0, useOverlay_1.useOverlay)(iframeRef), opacity = _b.opacity, display = _b.display;
    var onSuccess = props.onSuccess, onError = props.onError;
    (0, react_1.useEffect)(function () {
        if (!onSuccess)
            return;
        if (!(iframeRef === null || iframeRef === void 0 ? void 0 : iframeRef.current))
            return;
        iframeRef.current
            .listenForMessage(function (data) {
            try {
                var res = JSON.parse(data);
                if ('method' in res && res.data.startsWith('ERROR')) {
                    onError === null || onError === void 0 ? void 0 : onError(res.info);
                    return false;
                }
                return 'method' in res && res.method === 'getToken';
            }
            catch (e) {
                return false;
            }
        })
            .then(function (data) { return onSuccess === null || onSuccess === void 0 ? void 0 : onSuccess(data); });
    }, [onError, onSuccess]);
    var handleHeightChangeId = (0, CoinflowIFrame_1.useRandomHandleHeightChangeId)();
    var iframeProps = (0, react_1.useMemo)(function () {
        var walletPubkey = (0, common_1.getWalletPubkey)(props);
        return tslib_1.__assign(tslib_1.__assign({}, props), { walletPubkey: walletPubkey, transaction: undefined, routePrefix: 'form', route: "/".concat(route, "/").concat(props.merchantId), handleHeightChangeId: handleHeightChangeId });
    }, [handleHeightChangeId, props, route]);
    var messageHandlers = (0, react_1.useMemo)(function () {
        return tslib_1.__assign(tslib_1.__assign({}, (0, common_1.getHandlers)(props)), { handleHeightChange: props.handleHeightChange });
    }, [props]);
    return (react_1.default.createElement("div", { style: {
            position: 'relative',
            height: '100%',
        } },
        react_1.default.createElement("div", { style: {
                backgroundColor: props.color,
                width: '100%',
                height: '40px',
                position: 'absolute',
                top: 0,
                bottom: 0,
                left: 0,
                zIndex: 20,
                display: overlayDisplayOverride !== null && overlayDisplayOverride !== void 0 ? overlayDisplayOverride : display,
                opacity: opacity,
                justifyContent: 'center',
                alignItems: alignItems,
                pointerEvents: 'none',
            } }, children),
        react_1.default.createElement("div", { style: {
                position: 'relative',
                zIndex: 10,
                height: '100%',
            } },
            react_1.default.createElement(CoinflowIFrame_1.CoinflowIFrame, tslib_1.__assign({ ref: iframeRef }, iframeProps, messageHandlers)))));
}
//# sourceMappingURL=MobileWalletButton.js.map