import { __assign } from "tslib";
import { getHandlers, getWalletPubkey, } from './common';
import React, { useEffect, useMemo, useRef } from 'react';
import { CoinflowIFrame, useRandomHandleHeightChangeId, } from './CoinflowIFrame';
import { useOverlay } from './useOverlay';
export function MobileWalletButton(_a) {
    var props = _a.props, route = _a.route, overlayDisplayOverride = _a.overlayDisplayOverride, children = _a.children, alignItems = _a.alignItems;
    var iframeRef = useRef(null);
    var _b = useOverlay(iframeRef), opacity = _b.opacity, display = _b.display;
    var onSuccess = props.onSuccess, onError = props.onError;
    useEffect(function () {
        if (!onSuccess)
            return;
        if (!(iframeRef === null || iframeRef === void 0 ? void 0 : iframeRef.current))
            return;
        iframeRef.current
            .listenForMessage(function (data) {
            try {
                var res = JSON.parse(data);
                if ('method' in res && res.data.startsWith('ERROR')) {
                    onError === null || onError === void 0 ? void 0 : onError(res.info);
                    return false;
                }
                return 'method' in res && res.method === 'getToken';
            }
            catch (e) {
                return false;
            }
        })
            .then(function (data) { return onSuccess === null || onSuccess === void 0 ? void 0 : onSuccess(data); });
    }, [onError, onSuccess]);
    var handleHeightChangeId = useRandomHandleHeightChangeId();
    var iframeProps = useMemo(function () {
        var walletPubkey = getWalletPubkey(props);
        return __assign(__assign({}, props), { walletPubkey: walletPubkey, transaction: undefined, routePrefix: 'form', route: "/".concat(route, "/").concat(props.merchantId), handleHeightChangeId: handleHeightChangeId });
    }, [handleHeightChangeId, props, route]);
    var messageHandlers = useMemo(function () {
        return __assign(__assign({}, getHandlers(props)), { handleHeightChange: props.handleHeightChange });
    }, [props]);
    return (React.createElement("div", { style: {
            position: 'relative',
            height: '100%',
        } },
        React.createElement("div", { style: {
                backgroundColor: props.color,
                width: '100%',
                height: '40px',
                position: 'absolute',
                top: 0,
                bottom: 0,
                left: 0,
                zIndex: 20,
                display: overlayDisplayOverride !== null && overlayDisplayOverride !== void 0 ? overlayDisplayOverride : display,
                opacity: opacity,
                justifyContent: 'center',
                alignItems: alignItems,
                pointerEvents: 'none',
            } }, children),
        React.createElement("div", { style: {
                position: 'relative',
                zIndex: 10,
                height: '100%',
            } },
            React.createElement(CoinflowIFrame, __assign({ ref: iframeRef }, iframeProps, messageHandlers)))));
}
//# sourceMappingURL=MobileWalletButton.js.map