import React, { useEffect } from 'react';
export function useOverlay(iframeRef) {
    var _a = React.useState(false), messageReceived = _a[0], setMessageReceived = _a[1];
    var _b = React.useState(true), showOverlay = _b[0], setShowOverlay = _b[1];
    useEffect(function () {
        var _a;
        (_a = iframeRef === null || iframeRef === void 0 ? void 0 : iframeRef.current) === null || _a === void 0 ? void 0 : _a.listenForMessage(function (message) {
            try {
                var res = JSON.parse(message);
                return 'method' in res && res.method === 'loaded';
            }
            catch (e) {
                return false;
            }
        }).then(function () {
            setMessageReceived(true);
            setTimeout(function () {
                setShowOverlay(false);
            }, 2000);
        });
    }, [iframeRef]);
    var opacity = messageReceived ? 1 : 0.8;
    var display = showOverlay ? 'flex' : 'none';
    return { messageReceived: messageReceived, showOverlay: showOverlay, opacity: opacity, display: display };
}
//# sourceMappingURL=useOverlay.js.map